// 2007/09/01 Hiroyuki Ogasawara
// vim:ts=4 sw=4:
// http://dench.flatlib.jp/

#include	<stdio.h>

#include	"StaticTaskSystem.h"
#include	"tmain.h"



#include	"taskdraw.h"
#include	"taskmatsu.h"




//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------

template<typename A, int pri=A::priority>
struct itask {
	enum {
		value= pri,
	};
	static void Exec();
};


//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------

typedef	TS::Array<

			itask<Camera>,
			itask<MoveMatsu>,
			itask<DrawMatsu>,

			itask<DrawMenu>,

			itask<Input>,
			itask<RenderShadow>,
			itask<DrawFlip>,
			itask<DrawBegin>,
			itask<DrawEnd>

			>	TaskList;



//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------

static _TaskBase*	_InstanceList[ TS::Length<TaskList>::value ];

template<typename A, int pri>
void itask<A,pri>::Exec()
{
	_TaskBase*	_inst= _InstanceList[ TS::Index<TaskList,itask<A> >::value ];
printf( "pri=%5d\t", A::priority );
	reinterpret_cast<A*>( _inst )->Func();
}

template<typename A>
void RegisterTask( A* task )
{
	_InstanceList[ TS::Index<TaskList,itask<A> >::value ]= task;
}

//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------


int
main()
{
	RegisterTask( new Camera(1323) );
	RegisterTask( new MoveMatsu );
	RegisterTask( new DrawMatsu );



	TS::ExecTask< TS::Sort<TaskList>::result >::Exec();

	return	0;
}




